#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

typedef struct cvor * PCVOR;

typedef struct cvor {
	int podatak;
	PCVOR sledeci;
} CVOR;

void dodavanjeElementaNaKrajListe(PCVOR *glava, PCVOR *rep, int podatak);
void dodavanjeElementaNaPocetakListe(PCVOR *glava, PCVOR *rep, int podatak);
void prikazListe(PCVOR glava);
double aritmetickaSredinaListe(PCVOR glava);
void izbacivanjeElementaSaPocetkaListe(PCVOR *glava, PCVOR *rep);
void izbacivanjeElementaSaKrajaListe(PCVOR *glava, PCVOR *rep);
void izbacivanjeZadatogElementaIzListe(PCVOR *glava, PCVOR *rep, int zadati);

int main(void) {
	PCVOR glava=NULL;
	PCVOR rep=NULL;
	dodavanjeElementaNaPocetakListe(&glava, &rep, 15);
	dodavanjeElementaNaPocetakListe(&glava, &rep, 20);
	dodavanjeElementaNaPocetakListe(&glava, &rep, 25);
	dodavanjeElementaNaPocetakListe(&glava, &rep, 30);

	prikazListe(glava);

	printf("Aritmeticka sredina liste je %.2lf\n", aritmetickaSredinaListe(glava));

	izbacivanjeZadatogElementaIzListe(&glava, &rep, 20);
	prikazListe(glava);

	system("pause");
	return 0;
}

void dodavanjeElementaNaKrajListe(PCVOR *glava, PCVOR *rep, int podatak) {
	PCVOR novi = (PCVOR) malloc(sizeof(CVOR));
	novi->podatak = podatak;
	novi->sledeci = NULL;

	if (*glava == NULL) {
		*glava = novi;
		*rep = novi;
	}
	else {
		(*rep)->sledeci = novi;
		*rep = novi;
	}
}

void dodavanjeElementaNaPocetakListe(PCVOR *glava, PCVOR *rep, int podatak) {
	PCVOR novi = (PCVOR)malloc(sizeof(CVOR));
	novi->podatak = podatak;
	novi->sledeci = *glava;

	if (*glava == NULL) {
		*glava = novi;
		*rep = novi;
	}
	else {
		*glava = novi;
	}
}

void prikazListe(PCVOR glava) {
	PCVOR tek = glava;
	printf("Elementi liste su:\n");
	while (tek != NULL) {
		printf("%d\t", tek->podatak);
		tek = tek->sledeci;
	}
	printf("\n");
}

double aritmetickaSredinaListe(PCVOR glava) {
	int suma = 0;
	int brojElemenata = 0;
	PCVOR tek = glava;
	while (tek != NULL) {
		suma += tek->podatak;
		brojElemenata++;
		tek = tek->sledeci;
	}
	return (double)suma / (double)brojElemenata;
}

void izbacivanjeElementaSaPocetkaListe(PCVOR *glava, PCVOR *rep) {
	PCVOR tek=*glava;
	if (*glava == NULL) {
		printf("Izbacivanje nije moguce - lista je prazna!\n");
		return;
	}

	if (*glava == *rep) {
		*glava = NULL;
		*rep = NULL;
	}else {
		*glava = (*glava)->sledeci;
	}
	printf("Izbacen je broj %d!\n", tek->podatak);
	free(tek);
	tek = NULL;
}

void izbacivanjeElementaSaKrajaListe(PCVOR *glava, PCVOR *rep) {
	PCVOR tek = *rep;
	PCVOR pom = *glava;
	if (*glava == NULL) {
		printf("Izbacivanje nije moguce - lista je prazna!\n");
		return;
	}

	if (*glava == *rep) {
		*glava = NULL;
		*rep = NULL;
	}
	else {
		while (pom->sledeci != *rep) {
			pom = pom->sledeci;
		}
		*rep = pom;
		pom->sledeci = NULL;
	}
	printf("Izbacen je broj %d!\n", tek->podatak);
	free(tek);
	tek = NULL;
}

void izbacivanjeZadatogElementaIzListe(PCVOR *glava, PCVOR *rep, int zadati) {
	PCVOR tek = *glava;
	PCVOR prethodni = NULL;
	if (*glava == NULL) {
		printf("Izbacivanje nije moguce - lista je prazna!\n");
		return;
	}
	while (tek != NULL && tek->podatak != zadati) {
		prethodni = tek;
		tek = tek->sledeci;
	}

	if (tek == NULL) {
		printf("Izbacivanje nije moguce - u listi ne postoji zadati element!\n");
		return;
	}
	
	if (tek == *glava) {
		izbacivanjeElementaSaPocetkaListe(glava, rep);
		return;
	}
	if (tek == *rep) {
		izbacivanjeElementaSaKrajaListe(glava, rep);
		return;
	}
	
	prethodni->sledeci = tek->sledeci;
	printf("Izbacen je zadati element %d\n", zadati);
	free(tek);
	tek = NULL;
}